# -----------------------------------------------------------------------------
# File Name: alipayWap.py
# Author:    X. Peng
# -----------------------------------------------------------------------------
# pip3 install alipay-python
# -----------------------------------------------------------------------------
# Imports
# -----------------------------------------------------------------------------

from alipay import AliPay
import ssl
import time

# -----------------------------------------------------------------------------
# Constants
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Functions
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Classes
# -----------------------------------------------------------------------------


alipay_public_key_string = ''''''

app_private_key_string = ''''''

APP_ID = ''
URL_PREFIX = ''
ssl._create_default_https_context = ssl._create_unverified_context


def init_alipay(notify_path='/webservice/notify'):
    """初始化alipay配置."""
    alipay = AliPay(
        appid=APP_ID,
        app_notify_url=URL_PREFIX+notify_path,
        app_private_key_string=app_private_key_string,
        alipay_public_key_string=alipay_public_key_string,
        # 支付宝的公钥，验证支付宝回传消息使用，不是你自己的公钥,
        sign_type="RSA2",  # RSA 或者 RSA2
        debug=False  # 默认False ,若开启则使用沙盒环境的支付宝公钥
    )
    return alipay


def prePay(subject, out_trade_no, total_amount, notify_path='/webservice/notify', return_path='/home/order'):
    """创建预付订单."""
    result = init_alipay(notify_path).api_alipay_trade_wap_pay(
        subject=subject,
        out_trade_no=out_trade_no,
        total_amount=total_amount,
        return_url=URL_PREFIX + return_path
    )
    if not result:
        return False
    pay_url = 'https://openapi.alipay.com/gateway.do?' + result
    return pay_url

def alipay_transfer():
    """转账"""
    out_biz_no = time.strftime('%Y%m%d', time.localtime(time.time())) + str(int(time.time() * 1000))
    payee_type = 'ALIPAY_LOGONID'
    payee_account = '18916991859@163.com'
    amount = '1'
    kwargs = {
        'payee_real_name': '',
        'remark': ''
    }
    result = init_alipay().api_alipay_fund_trans_toaccount_transfer(out_biz_no, payee_type, payee_account, amount, **kwargs)
    return result
